// -*- mode:javascript; indent-tabs-mode:t; js-indent-level:8; -*-
//
//	This program is licensed under the GPL v3.0, which is found at the URL below:
//	http://opensource.org/licenses/gpl-3.0.html
//
//	Copyright (c) 2015, Wei Wang. All rights reserved.

'use strict';
const fs = require('fs');
const readline = require('readline');
const assert = require('assert');
const tar = require('tar');
const zlib = require('zlib');
const util = require('util');
const test = require("tap").test;

const archive = './tarball.tar.gz';

test('NetScaler config read test', t => {
	const nsconf = 'tap-tar.js';
	let count = 0;

	fs.createReadStream(archive).on('error', console.error)
		.pipe(zlib.createUnzip())
		.pipe(new tar.Parse())
		.on('entry', entry => {
			if (entry.path.endsWith(nsconf)) {
				console.log('----> Found ns.conf:', entry.path);
				if (!t.ok('File' == entry.type)) {
					throw new Error('Wrong type for entry: '+nsconf+' : '+entry.type);
				}
				readline.createInterface({
					input: entry
				}).on('line', line => {
					count++
					console.log(line);
				}).on('close', () => {
					console.log('----> Closing file. Line count = '+count);
					t.end();
				});
			} else {
				entry.resume();
			}
		});
});
